app/Http/routes.php
<?php
/**
 * Application Routes
 *
 * Here is where you can register all of the routes for an application.
 * It's a breeze. Simply tell Laravel the URIs it should respond to
 * and give it the controller to call when that URI is requested.
 *
 * PHP version 5.6
 *
 * @category Class
 * @package  Base
 * @author   Michal Hojgr <michal.hojgr@gmail.com>
 * @license  MS Reference
 * @link     http://bookie.gg
 */
/*
|--------------------------------------------------------------------------
| Application Routes
|--------------------------------------------------------------------------
|
| Here is where you can register all of the routes for an application.
| It's a breeze. Simply tell Laravel the URIs it should respond to
| and give it the controller to call when that URI is requested.
|
*/

Route::get('/mailpreview', ['uses' => 'EmailController@firstclosedbeta']);
Route::get('/help', ['as' => 'help', 'uses' => 'HelpController@show']);

Route::group(
    ['middleware' => 'beta.active_only'],
    function () {
        /**
         * API Methods
         *
         * @see http://docs.bookiegg.apiary.io/
         */
        Route::post(
            '/api/csgo/bank/deposit',
            ['uses' => 'BankController@deposit']
        );

        Route::post(
            '/api/csgo/bank/withdraw',
            ['uses' => 'BankController@withdraw']
        );

        Route::get(
            '/api/profile/tradeurl/verify',
            ['uses' => 'ProfileController@verifyTradeURL']
        );

        Route::post(
            '/api/profile/tradeurl',
            ['uses' => 'ProfileController@storeTradeURL']
        );

        Route::post(
            '/api/core/popup',
            ['uses' => '']
        );

        Route::get(
            '/api/core/popup',
            ['uses' => 'PopupController@getActive']
        );

        Route::get(
            '/',
            ['as' => 'home', 'uses' => 'HomeController@index']
        );
        Route::get(
            '/profile/{id}',
            ['as' => 'profile', 'uses' => 'ProfileController@show']
        );
        Route::get(
            '/article/{id}',
            ['as' => 'article', 'uses' => 'ArticleController@show']
        );
        Route::get(
            '/match/{id}',
            ['as' => 'match', 'uses' => 'MatchController@show']
        );
        Route::get(
            '/bank',
            ['as' => 'bank', 'uses' => 'BankController@show']
        );
        Route::get(
            '/rules',
            ['as' => 'rules', 'uses' => 'SubpageController@rules']
        );
        Route::get(
            '/tos',
            ['as' => 'tos', 'uses' => 'SubpageController@tos']
        );
        Route::get(
            '/contact',
            ['as' => 'contact', 'uses' => 'SubpageController@contact']
        );
        Route::get(
            '/partners',
            ['as' => 'partners', 'uses' => 'SubpageController@partners']
        );

        // TODO: add admin roles
        Route::group(
            [
                'namespace' => 'Admin',
                'prefix' => 'admin',
                'middleware' => 'admin.protect'
            ],
            function () {
                Route::get(
                    '/',
                    ['as' => 'admin_home', 'uses' => 'HomeController@index']
                );

                Route::resource('article', 'ArticleController');
                Route::resource('organization', 'OrganizationController');
                Route::resource('team', 'TeamController');
                Route::resource('match', 'MatchController');

                Route::get(
                    'match/pickwinner/{matchid}/{tid}',
                    [
                        'as' => 'admin.match.pickwinner',
                        'uses' => 'MatchController@pickwinner'
                    ]
                );
                Route::resource('subpage', 'SubpageController');
            }
        );
    }
);


Route::group(
    ['middleware' => 'beta.not_active_only'],
    function () {
        Route::get(
            '/beta',
            ['as' => 'beta_home', 'uses' => 'BetaController@index']
        );
        Route::post(
            '/beta',
            ['as' => 'beta.activate', 'uses' => 'BetaController@activate']
        );
        Route::post(
            '/beta/subscribe',
            ['as' => 'beta.subscribe', 'uses' => 'BetaSubscribeController@index']
        );
    }
);

Route::get('/login', ['as' => 'login', 'uses' => 'SteamController@login']);
Route::get('/auth', ['as' => 'auth', 'uses' => 'SteamController@auth']);
Route::get('/logout', ['as' => 'logout', 'uses' => 'SteamController@logout']);

/**
 * Statically serve images from storage
 */
Route::get(
    'upload_assets/{thing}/{type}/{filename}',
    [
        'as' => 'uploaded_asset',
        'uses' => function ($thing, $type, $filename) {
            if (!in_array($thing, ['logo', 'banner'])) {
                App::abort(403);
            }

            $path = storage_path($thing . "s/" . $type . "s") . "/$filename";

            $response = Response::make(File::get($path));
            $response->header('Content-Type', File::type($path));
            $response->header('Content-Size', File::size($path));

            return $response;
        }
    ]
);

app/Models/Article.php
<?php namespace BookieGG\Models;

use Illuminate\Database\Eloquent\Model;

class Article extends Model {

    public function user() {
        return $this->belongsTo('BookieGG\Models\User');
    }

}

app/Http/Controllers/Admin/ArticleController.php
<?php namespace BookieGG\Http\Controllers\Admin;

use BookieGG\Commands\CreateArticle;
use BookieGG\Commands\UpdateArticle;
use BookieGG\Http\Requests;
use BookieGG\Http\Controllers\Controller;

use BookieGG\Repositories\Eloquent\ArticleRepository;
use Illuminate\Http\Request;

class ArticleController extends Controller {

    /**
     * Display a listing of the resource.
     *
     * @param ArticleRepository $ar
     * @return Response
     */
    public function index(ArticleRepository $ar)
    {
        return view('admin/article/index')->with('articles', $ar->all());
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param Requests\AdminArticleCreate $article
     * @return Response
     */
    public function store(Requests\AdminArticleCreate $article)
    {
        $this->dispatch(new CreateArticle(\Auth::user(), \Input::get('title'), \Input::get('text')));

        return \Redirect::route('admin.article.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param ArticleRepository $ar
     * @param  int $id
     * @return Response
     */
    public function edit(ArticleRepository $ar, $id)
    {
        return view('admin/article/edit')->with('articles', $ar->all())->with('article', $ar->find($id));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param Requests\AdminArticleCreate $article
     * @param  int $id
     * @return Response
     */
    public function update(Requests\AdminArticleCreate $article, $id)
    {
        $this->dispatch(new UpdateArticle($id, \Input::get('title'), \Input::get('text')));

        return \Redirect::route('admin.article.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return Response
     */
    public function destroy($id)
    {
        //
    }

}

app/Http/Controllers/ArticleController.php
<?php namespace BookieGG\Http\Controllers;

use BookieGG\Contracts\Repositories\ArticleRepositoryInterface;
use BookieGG\Http\Requests;

use Illuminate\Http\Request;

class ArticleController extends Controller {

    /**
     * Display the specified resource.
     *
     * @param ArticleRepositoryInterface $ari
     * @param  int $id
     * @return Response
     */
    public function show(ArticleRepositoryInterface $ari, $id)
    {
        return view('news/index')->with('article', $ari->find($id));
    }

}

resources/views/admin/article/edit.blade.php
@extends('admin/app')

@section('content')
	<div class="content-box">
		<script src="//cdn.ckeditor.com/4.4.7/standard/ckeditor.js"></script>

		<h2>Edit!</h2>

		@foreach($errors->all() as $error)
			<span class="error" style="color: white">{{ $error }}</span>
		@endforeach

		{!! Form::open(['url' => route('admin.article.update', $article->id), 'method' => 'PATCH']) !!}
		{!! Form::text('title', $article->title, array('placeholder' => 'Title of article', 'class' => 'form-control')) !!}<br />
		{!! Form::textarea('text', $article->content, array('placeholder' => 'Text of article')) !!}<br />

		{!! Form::submit('Submit changed', ['class' => 'btn btn-primary']) !!}
		{!! Form::close() !!}
		<script>
			// Replace the <textarea id="editor1"> with a CKEditor
			// instance, using default configuration.
			CKEDITOR.replace('text');
		</script>
	</div>
@endsection


@section('rightside')
	<div class="right-side">
		<h3 style="margin-left: 10px">Articles</h3>
		<ul>
			@foreach($articles as $a)
			<li><a href="{{ route('admin.article.edit', $a->id) }}">{{ str_limit($a->title, 32) }}</a></li>
			@endforeach
		</ul>
	</div>
@endsection

resources/views/admin/article/index.blade.php
@extends('admin/app')

@section('content')
	<div class="content-box">
		<script src="//cdn.ckeditor.com/4.4.7/standard/ckeditor.js"></script>

		@if($errors->count())
			<h2>{{ $errors->count() }} errors while creating an article!</h2>
		@else
			<h2>Create new article!</h2>
		@endif
		<ul class="validation">
			@foreach($errors->all() as $error)
				<li class="error">{{ $error }}</li>
			@endforeach
		</ul>

		<h3>Fix the errors and submit again</h3>

		{!! Form::open(['route' => 'admin.article.store']) !!}
		{!! Form::text('title', null, array('placeholder' => 'Title of article', 'class' => 'form-control')) !!}<br />
		{!! Form::textarea('text', null, array('placeholder' => 'Text of article')) !!}<br />

		{!! Form::submit('Submit', ['class' => 'btn btn-primary']) !!}
		{!! Form::close() !!}
		<script>
			// Replace the <textarea id="editor1"> with a CKEditor
			// instance, using default configuration.
			CKEDITOR.replace('text');
		</script>
	</div>
@endsection


@section('rightside')
	<div class="right-side">
		<h3 style="margin-left: 10px">Articles</h3>
		<ul>
			@foreach($articles as $a)
			<li><a href="{{ route('admin.article.edit', $a->id) }}">{{ str_limit($a->title, 32) }}</a></li>
			@endforeach
		</ul>
	</div>
@endsection